Search in Rotated Sorted Array 旋转数组里查找数 @LeetCode

二分法的变型题

FollowUp 是如果数组里有重复元素怎么办?

其实没所谓。

http://blog.csdn.net/fightforyourdream/article/details/16857291


package Level4;

/**
 * Search in Rotated Sorted Array
 * 
 * Suppose a sorted array is rotated at some pivot unknown to you beforehand.
 * 
 * (i.e., 0 1 2 4 5 6 7 might become 4 5 6 7 0 1 2).
 * 
 * You are given a target value to search. If found in the array return its
 * index, otherwise return -1.
 * 
 * You may assume no duplicate exists in the array.
 * 
 */
public class S33 {

	public static void main(String[] args) {
		int[] A = {2, 3, 4, 5, 6, 0, 1};
		System.out.println(search(A, 0));
	}

	public static int search(int[] A, int target) {
		return rec(A, target, 0, A.length-1);
	}
	
	// 递归查找
	public static int rec(int[] A, int target, int low, int high){
		if(low > high){				// 没找到的情况
			return -1;
		}
		
		int mid = low + (high-low)/2;
		if(A[mid] == target){		// 找到了
			return mid;
		}
		
		int res = rec(A, target, low, mid-1);		// 在左侧查找
		if(res == -1){			// 如果左侧没找到,继续在右侧查找
			res = rec(A, target, mid+1, high);
		}
		
		return res;
	}

}



解法就是直接分别对左半侧和右半侧搜索,用递归实现

public class Solution {
    public int search(int[] A, int target) {
        return rec(A, target, 0, A.length-1);
    }
    
    public int rec(int[] A, int target, int low, int high){
        if(low > high){
            return -1;
        }
        
        int mid = low + (high-low)/2;
        if(A[mid] == target){
            return mid;
        }
        int pos = rec(A, target, mid+1, high);
        if(pos != -1){
            return pos;
        }else{
            return rec(A, target, low, mid-1);
        }
    }
}


I have updated the problem description to assume that there exists no duplicate in the array. Some readers have noted that the below code does not work for input with duplicates. For example, for input “1 2 1 1 1 1″, the binary search method below would not work, as there is no way to know if an element exists in the array without going through each element one by one.

At first look, we know that we can do a linear search in O(n) time. But linear search does not need the elements to be sorted in any way.

First, we know that it is a sorted array that’s been rotated. Although we do not know where the rotation pivot is, there is a property we can take advantage of. Here, we make an observation that a rotated array can be classified as two sub-array that is sorted (i.e., 4 5 6 7 0 1 2 consists of two sub-arrays 4 5 6 7 and 0 1 2.

Do not jump to conclusion that we need to first find the location of the pivot and then do binary search on both sub-arrays. Although this can be done in O(lg n) time, this is not necessary and is more complicated.

In fact, we don’t need to know where the pivot is. Look at the middle element (7). Compare it with the left most (4) and right most element (2). The left most element (4) is less than (7). This gives us valuable information — All elements in the bottom half must be in strictly increasing order. Therefore, if the key we are looking for is between 4 and 7, we eliminate the upper half; if not, we eliminate the bottom half.

When left index is greater than right index, we have to stop searching as the key we are finding is not in the array.

Since we reduce the search space by half each time, the complexity must be in the order of O(lg n). It is similar to binary search but is somehow modified for this problem. In fact, this is more general than binary search, as it works for both rotated and non-rotated arrays.

二分法的·精髓在于只要能做到每次扔掉一半

int rotated_binary_search(int A[], int N, int key) {
  int L = 0;
  int R = N - 1;
 
  while (L <= R) {
    // Avoid overflow, same as M=(L+R)/2
    int M = L + ((R - L) / 2);
    if (A[M] == key) return M;
 
    // the bottom half is sorted
    if (A[L] <= A[M]) {
      if (A[L] <= key && key < A[M])
        R = M - 1;
      else
        L = M + 1;
    }
    // the upper half is sorted
    else {
      if (A[M] < key && key <= A[R])
        L = M + 1;
      else 
        R = M - 1;
    }
  }
  return -1;
}


扩展:

如何找pivot点:相当于找到最小的那个点:把中点和右边的点比较

int FindSortedArrayRotation(int A[], int N) {
  int L = 0;
  int R = N - 1;
  
  while (A[L] > A[R]) {
    int M = L + (R - L) / 2;
    if (A[M] > A[R])
      L = M + 1;
    else
      R = M;
  }
  return L;
}




评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值